require "faraday"
require "json"

require "academical/api/schools"
require "academical/api/sections"
require "academical/api/teachers"

module Academical

  class Client

    def initialize(auth = {}, options = {})
      @http_client = Academical::HttpClient::HttpClient.new(auth, options)
    end

    # All schools that are using Academical
    def schools()
      Academical::Api::Schools.new(@http_client)
    end

    # Represents the section of a course in a school
    def sections()
      Academical::Api::Sections.new(@http_client)
    end

    # A teacher in a school.
    def teachers()
      Academical::Api::Teachers.new(@http_client)
    end

  end

end
